
// An existing HTML+JS app requires the following changes:

//1) add DIV for the RFID connection status:
//<div id="rfidstatus"> </div>

//2) add RFID initialisation call when form loads:
//<body onload=startIntentListener() >

//3) ensure that the EB includes below are present under the <head> section (elements.js and ebapi-modules.js)y
// <script type="text/javascript" charset="utf-8" src="elements.js"></script>
//<script type="text/javascript" charset="utf-8" src="ebapi-modules.js"></script>

//4) Copy all the JavaScript functions below and paste them into the <script> area of the target app

//5) Check the rfid.transport device type matches the RFD connection type (bluetooth or usb)

//6) Modify the tag event handler (TagHandler) so that the incoming tags are processed in the target app





// ****** Start RFID Support Functions ********

function rfidEnumerate()
		{ 
		  // usb for RFD40 , bluetooth for RFD8500/RFD40
		  
		  rfid.transport= "usb";
		  //rfid.transport="bluetooth";
		  rfid.enumRFIDEvent = "EnumRfid(%s);"
		  rfid.enumerate();    
		  
			 
		}
		
		// enumerate callback 
		
		function EnumRfid(rfidArray)
		{ 
		  var rfidInfo = "RFID On Device: " + rfidArray.length + "--";  
		 		  
		  for (var i=0; i < rfidArray.length; i++)
		  { 
			 rfidInfo = rfidInfo +"ID:"+ rfidArray[i][0] + '\nname:'+ rfidArray[i][1] + '\naddress '+rfidArray[i][2]; 
		  }
		   
		   //document.getElementById("reader").innerHTML=rfidInfo;
		}	
		
		

function rfidConnect(){
			 rfid.readerID="RFID1";	  
			 rfid.connect();  
			 rfid.reportUniqueTags=1;
		 	 rfid.beepOnRead=0;
			 rfid.stopTriggerType = "triggerRelease";
			 
			 
			  
        }
				
		function rfidDisConnect(){
			rfid.disconnect();
			 
        }	
			
			
function sleep(milliseconds) {
  const date = Date.now();
  let currentDate = null;
  do {
    currentDate = Date.now();
  } while (currentDate - date < milliseconds);
}


  function startIntentListener(){
		
		    // define tag event handlers
			
			rfid.statusEvent =  "statusEvent(%json)";
			rfid.tagEvent = "TagHandler(%json)";
			rfid.enableTagRSSI=true;
			
             
			// get connected reader details

			rfidEnumerate();
			 
			// ensure current connection is reset
			
			rfidDisConnect();
			// delay for enumerate to complete
			
			sleep(2000);
			
			// connect to reader
			
			//alert("Connecting...");
			
			rfidConnect();
			
			 
        }


 // RFID tag event handler
				
	function TagHandler(tagarray)
		{		
		     
			 var prefilter="";
			 
			 
			for (i=0; i < tagarray.TagData.length; i++)
		    {
			
		        var tagid=tagarray.TagData[i].tagID;
			   
 
				// vibrate on filtered tag read
			    EB.Notification.vibrate(100)
				// EB.Notification.beep({'frequency': 900, 'volume': 3, 'duration': 100}, null);
				 
				// APP SPECIFIC:check if tagid matches item in checklist
				 		 

                addItemToList(tagid);
				
				
				
			}  
		 
		}
		
		// RFID Status Event Handler

		function statusEvent(eventInfo)
		{
		// make sure DIV is defined for these status messages
		if (eventInfo.vendorMessage.startsWith("CONNECT"))
		 document.getElementById("rfidstatus").innerHTML='<p style="color:green;">Reader :<b> CONNECTED</b></p>';
		if (eventInfo.vendorMessage.startsWith("DISCONNECT"))
		 document.getElementById("rfidstatus").innerHTML='<p style="color:red;">Reader :<b> DISCONNECTED</b></p>';
		 
		 
		}


    function prefixSet()
	  {
	       
			
		   // configure pre-filter
			 
			rfid.preFilterID = 1;
			rfid.preFilterMemBank = "EPC";
			rfid.preFilterBitOffset = 32;
			var prefilter=document.getElementById('prefix').value;
			
			rfid.preFilterHexPattern =  prefilter;
			document.getElementById("itemstatus").innerHTML="ADDED PREFILTER:"+prefilter;
			
			rfid.preFilterBitCount = prefilter.length*4;
			 
			rfid.addPreFilter();
			
			
	  }
	  
	  function prefixClear()
	  {
	   document.getElementById("prefix").value="";
	 
	   
	   rfid.clearPreFilter();
		
	   document.getElementById("itemstatus").innerHTML="FILTERS CLEARED";
	  }
	  


// ************ End RFID Support Functions ***********
